"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var console_1 = require("../../services/console");
var validation_chain_1 = __importDefault(require("../../services/validation-chain"));
var daemon_metadata_utils_1 = require("@mamoru-ai/validation-chain-ts-client/dist/validationchain.validationchain/types/validationchain/validationchain/daemon_metadata_utils");
var prompts_1 = require("@inquirer/prompts");
var colors_1 = __importDefault(require("colors"));
var constants_1 = require("../../services/constants");
var chain_1 = require("@mamoru-ai/validation-chain-ts-client/dist/validationchain.validationchain/types/validationchain/validationchain/chain");
var utils_1 = require("../../utils/utils");
var graphql_api_service_1 = require("../../services/graphql-api/graphql-api.service");
var env = process.env.NODE_ENV;
function launch(program, options) {
    return __awaiter(this, void 0, void 0, function () {
        var metadataId, verbosity, logger, vcService, metadata, finalChain, finalParameterValues, result, gqlres;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    metadataId = options.metadataId;
                    verbosity = program.opts().verbose;
                    logger = new console_1.Logger(verbosity);
                    logger.verbose("LaunchOptions ".concat(JSON.stringify(options, null, 2)));
                    (0, utils_1.validateAndParseParameterFlag)(options.parameters);
                    vcService = new validation_chain_1.default(options.rpc, options.privateKey, logger);
                    return [4 /*yield*/, vcService
                            .getDaemonMetadataById(metadataId)
                            .catch(function (err) {
                            err.message = "Error retrieving metadata \"".concat(metadataId, "\": ").concat(err.message);
                            throw err;
                        })];
                case 1:
                    metadata = _a.sent();
                    if (!metadata) {
                        throw new Error('Metadata not found');
                    }
                    if (metadata.type !== daemon_metadata_utils_1.DaemonMetadataType.SUBCRIBABLE) {
                        throw new Error('Metadata is not subscribable');
                    }
                    if (metadata.supportedChains.length === 0) {
                        throw new Error('Metadata does not support any chain');
                    }
                    return [4 /*yield*/, queryChain(metadata, options)];
                case 2:
                    finalChain = _a.sent();
                    logger.verbose("Chain selected: ".concat(finalChain));
                    return [4 /*yield*/, (0, utils_1.queryDaemonParameters)(metadata, options, finalChain)];
                case 3:
                    finalParameterValues = _a.sent();
                    logger.verbose("Registering daemon with parameters: ".concat(JSON.stringify(finalParameterValues, null, 2)));
                    return [4 /*yield*/, vcService.registerDaemon(metadataId, finalChain, finalParameterValues, options.gas)];
                case 4:
                    result = _a.sent();
                    logger.log("Waiting for daemon to be assigned to organization...");
                    if (!(env == undefined)) return [3 /*break*/, 6];
                    return [4 /*yield*/, (0, graphql_api_service_1.assignOrganizationToDaemonRepeat)(result.daemonId, logger)];
                case 5:
                    gqlres = _a.sent();
                    logger.verbose("assignOrganizationToDaemon response: ".concat(JSON.stringify(gqlres, null, 2)));
                    _a.label = 6;
                case 6:
                    logger.log("Daemon registered successfully \uD83C\uDF89\n\n    \u2139\uFE0F  Daemon Hash(ID): \n\n        ".concat(colors_1.default.magenta(result.daemonId), "\n\n    \u2139\uFE0F  Explorer Url for parent DaemonMetadata:\n\n        ").concat(colors_1.default.underline.blue("".concat(constants_1.MAMORU_EXPLORER_URL, "/agents/").concat(metadataId))));
                    return [2 /*return*/, result];
            }
        });
    });
}
exports.default = launch;
function queryChain(metadata, options) {
    return __awaiter(this, void 0, void 0, function () {
        var chain;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (options.chain)
                        return [2 /*return*/, options.chain];
                    if (metadata.supportedChains.length === 1)
                        return [2 /*return*/, (0, chain_1.chain_ChainTypeToJSON)(metadata.supportedChains[0].chainType)];
                    return [4 /*yield*/, (0, prompts_1.select)({
                            message: 'To what chain do you want to register the daemon?',
                            choices: metadata.supportedChains.map(function (chain) { return ({
                                value: (0, chain_1.chain_ChainTypeToJSON)(chain.chainType),
                            }); }),
                        })];
                case 1:
                    chain = _a.sent();
                    return [2 /*return*/, chain];
            }
        });
    });
}
//# sourceMappingURL=launch.js.map