"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.loginCommand = void 0;
var auth_1 = require("../../services/auth");
var prompts_1 = require("@inquirer/prompts");
var console_1 = require("../../services/console");
var colors_1 = __importDefault(require("colors"));
function loginCommand(program) {
    return __awaiter(this, void 0, void 0, function () {
        var verbosity, logger, isAuthenticated, shouldLogInAgain, deviceCode, next, credentials;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    verbosity = program.opts().verbose;
                    logger = new console_1.Logger(verbosity);
                    return [4 /*yield*/, (0, auth_1.isUserAuthenticated)()];
                case 1:
                    isAuthenticated = _a.sent();
                    if (!isAuthenticated) return [3 /*break*/, 3];
                    return [4 /*yield*/, (0, prompts_1.confirm)({
                            message: 'You are already logged in. Would you like to log in again?',
                            default: false,
                        })];
                case 2:
                    shouldLogInAgain = _a.sent();
                    if (!shouldLogInAgain)
                        return [2 /*return*/, process.exit(0)];
                    _a.label = 3;
                case 3: return [4 /*yield*/, (0, auth_1.requestDeviceCode)()];
                case 4:
                    deviceCode = _a.sent();
                    logger.log("First copy your one-time code: ".concat(colors_1.default.magenta(deviceCode.user_code)));
                    return [4 /*yield*/, (0, prompts_1.confirm)({
                            message: 'Press enter when you are ready to open the browser and authenticate',
                            default: true,
                        })];
                case 5:
                    next = _a.sent();
                    if (!next)
                        return [2 /*return*/, process.exit(0)];
                    logger.log("Opening browser, if it does not open, please copy this url: ".concat(colors_1.default.underline(colors_1.default.blue(deviceCode.verification_uri))));
                    return [4 /*yield*/, (0, auth_1.openDeviceActivationUrl)(deviceCode.verification_uri)];
                case 6:
                    _a.sent();
                    return [4 /*yield*/, askForCodeUntilAuthenticated(deviceCode.device_code, deviceCode.interval, logger)];
                case 7:
                    credentials = _a.sent();
                    (0, auth_1.storeUserToken)(credentials.access_token);
                    logger.ok('You are now logged in!');
                    return [2 /*return*/];
            }
        });
    });
}
exports.loginCommand = loginCommand;
var askForCodeUntilAuthenticated = function (deviceCode, interval, logger) { return __awaiter(void 0, void 0, void 0, function () {
    var tokens;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                logger.verbose('askForCodeUntilAuthenticated', deviceCode, interval);
                return [4 /*yield*/, (0, auth_1.requestTokens)(deviceCode)];
            case 1:
                tokens = _a.sent();
                if (tokens) {
                    logger.verbose('tokens', tokens);
                    return [2 /*return*/, tokens];
                }
                // repeat this same function in 5 seconds
                return [4 /*yield*/, delay(interval * 1000)];
            case 2:
                // repeat this same function in 5 seconds
                _a.sent();
                return [2 /*return*/, askForCodeUntilAuthenticated(deviceCode, interval, logger)];
        }
    });
}); };
function delay(millis) {
    return new Promise(function (resolve, reject) {
        setTimeout(function () { return resolve(null); }, millis);
    });
}
//# sourceMappingURL=auth.js.map