import { Command } from 'commander';
import { Logger } from '../../services/console';
import { PLAYBOOK_FILES } from '../../services/constants';
declare function initPlaybook(program: Command, projectPath: string, options: PlaybookOptions): Promise<void>;
declare function getAugmentedInitOptions(options: PlaybookOptions, projectPath: string): Promise<AugmentedPlaybookOptions>;
declare function getFilesToCreate(projectPath: string): Partial<typeof PLAYBOOK_FILES>;
declare function createFile(logger: Logger, ops: AugmentedPlaybookOptions, templatePath: string, targetPath: string): void;
export interface PlaybookOptions {
    name: string;
}
export interface AugmentedPlaybookOptions extends PlaybookOptions {
    kebabName: string;
}
declare const _default: {
    initPlaybook: typeof initPlaybook;
    getAugmentedInitOptions: typeof getAugmentedInitOptions;
    getFilesToCreate: typeof getFilesToCreate;
    createFile: typeof createFile;
};
export default _default;
//# sourceMappingURL=playbook-init.d.ts.map