"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var console_1 = require("../../services/console");
var path_1 = __importDefault(require("path"));
var constants_1 = require("../../services/constants");
var validation_chain_1 = __importDefault(require("../../services/validation-chain"));
var playbooks_dto_1 = require("@mamoru-ai/validation-chain-ts-client/dist/validationchain.validationchain/types/validationchain/validationchain/playbooks_dto");
var fs_1 = __importDefault(require("fs"));
var yaml_1 = __importDefault(require("yaml"));
var playbook_1 = require("../../services/playbook");
var colors_1 = __importDefault(require("colors"));
var graphql_api_service_1 = require("../../services/graphql-api/graphql-api.service");
var env = process.env.NODE_ENV;
function playbookPublish(program, projectPath, options) {
    return __awaiter(this, void 0, void 0, function () {
        var verbosity, logger, playbookYamlPath, vcService, yamlData, playbookData, playbook, daemonIds, existingDaemons, error_1, responsePlaybookId, response, error_2, response, error_3, action;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    verbosity = program.opts().verbose;
                    logger = new console_1.Logger(verbosity);
                    logger.verbose('Run playbook publish');
                    logger.verbose('options', options);
                    logger.verbose('projectPath', projectPath);
                    playbookYamlPath = path_1.default.join(projectPath, constants_1.PLAYBOOK_FILES.PLAYBOOK_YAML);
                    if (!fs_1.default.existsSync(playbookYamlPath)) {
                        program.error('The project path does not exist. Please specify a valid path to your project.');
                    }
                    logger.verbose("PublishOptions ".concat(JSON.stringify(options, null, 2)));
                    vcService = new validation_chain_1.default(options.rpc, options.privateKey, logger);
                    yamlData = fs_1.default.readFileSync(playbookYamlPath, 'utf8');
                    playbookData = yaml_1.default.parse(yamlData) // Use 'as any' for now
                    ;
                    if (!(0, playbook_1.isValidPlaybookManifest)(logger, playbookData)) {
                        logger.error('Playbook validation failed');
                        process.exit(1);
                    }
                    playbook = playbooks_dto_1.PlaybookDTO.fromJSON(playbookData);
                    logger.verbose("Playbook: ".concat(JSON.stringify(playbook, null, 2)));
                    if (!(env == undefined)) return [3 /*break*/, 4];
                    daemonIds = (0, playbook_1.getDaemonIdsFromPlaybook)(playbook);
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, (0, graphql_api_service_1.getDaemonsByIds)(daemonIds)];
                case 2:
                    existingDaemons = _a.sent();
                    logger.verbose('existingDaemons', existingDaemons);
                    logger.verbose('playbookDaemonIds', daemonIds);
                    if (existingDaemons.length < daemonIds.length) {
                        throw new Error("Some of the Agents specified in the playbook do not exist. Please check the daemon IDs and try again, \n                    \n                    Daemons found: ".concat(existingDaemons
                            .map(function (d) { return d.id; })
                            .join(', '), "\n                    "));
                    }
                    return [3 /*break*/, 4];
                case 3:
                    error_1 = _a.sent();
                    handleError(error_1);
                    return [3 /*break*/, 4];
                case 4:
                    responsePlaybookId = '';
                    if (!options.playbookId) return [3 /*break*/, 9];
                    _a.label = 5;
                case 5:
                    _a.trys.push([5, 7, , 8]);
                    return [4 /*yield*/, vcService.updatePlaybook(options.playbookId, playbook, options.gas)];
                case 6:
                    response = _a.sent();
                    logger.verbose('response', response);
                    responsePlaybookId = response.playbookId;
                    return [3 /*break*/, 8];
                case 7:
                    error_2 = _a.sent();
                    handleError(error_2);
                    return [3 /*break*/, 8];
                case 8: return [3 /*break*/, 12];
                case 9:
                    _a.trys.push([9, 11, , 12]);
                    return [4 /*yield*/, vcService.createPlaybook(playbook, options.gas)];
                case 10:
                    response = _a.sent();
                    logger.verbose('response', response);
                    responsePlaybookId = response.playbookId;
                    return [3 /*break*/, 12];
                case 11:
                    error_3 = _a.sent();
                    handleError(error_3);
                    return [3 /*break*/, 12];
                case 12:
                    logger.ok('Publishing to Validation chain');
                    action = options.playbookId ? 'updated' : 'created';
                    logger.log("Playbook ".concat(action, " successfully \uD83C\uDF89\n        \u2139\uFE0F  Playbook Hash(ID):\n            ").concat(colors_1.default.magenta(responsePlaybookId), "\n        \u2139\uFE0F  Explorer Url (it may take a few seconds to become available):\n            ").concat(colors_1.default.underline.blue("".concat(constants_1.MAMORU_EXPLORER_URL, "/playbooks/").concat(responsePlaybookId))));
                    return [2 /*return*/, {
                            responsePlaybookId: responsePlaybookId,
                        }];
            }
        });
    });
}
function handleError(error) {
    var message = '';
    if (error.errors) {
        for (var _i = 0, _a = error.errors; _i < _a.length; _i++) {
            var err = _a[_i];
            message += err.message + '\n';
        }
    }
    else {
        message = error;
    }
    throw new Error(message);
}
exports.default = {
    playbookPublish: playbookPublish,
};
//# sourceMappingURL=playbook-publish.js.map