#! /usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var colors_1 = __importDefault(require("colors"));
var fs = __importStar(require("fs"));
var commander_1 = require("commander");
var init_1 = __importDefault(require("./commands/agents/init"));
var build_1 = __importDefault(require("./commands/agents/build"));
var publish_1 = __importDefault(require("./commands/agents/publish"));
var launch_1 = __importDefault(require("./commands/agents/launch"));
var utils_1 = require("./services/utils");
var ask_for_telemetry_1 = require("./commands/ask-for-telemetry");
var playbook_init_1 = __importDefault(require("./commands/playbooks/playbook-init"));
var playbook_publish_1 = __importDefault(require("./commands/playbooks/playbook-publish"));
var daemon_remove_1 = __importDefault(require("./commands/agents/daemon-remove"));
var auth_1 = require("./commands/auth");
var auth_2 = require("./services/auth");
function parseOrSetCurrentDirectoryPath(path) {
    if (!path) {
        return '.';
    }
    if (fs.existsSync(path) && fs.lstatSync(path).isDirectory()) {
        return path;
    }
    else {
        throw new commander_1.InvalidArgumentError('Provided path does not exist or not a folder.');
    }
}
function parseOrCreateDirectoryPath(path) {
    if (path === '') {
        throw new commander_1.InvalidArgumentError('Path is required.');
    }
    if (fs.existsSync(path) && !fs.lstatSync(path).isDirectory()) {
        throw new commander_1.InvalidArgumentError('Provided path is not a folder.');
    }
    if (!fs.existsSync(path)) {
        fs.mkdirSync(path);
        return path;
    }
    if (fs.existsSync(path) && fs.lstatSync(path).isDirectory()) {
        return path;
    }
    throw new commander_1.InvalidArgumentError('Provided path does not exist or not a folder.');
}
function increaseVerbosity(dummyValue, previous) {
    return previous + 1;
}
commander_1.program.name('mamoru-cli');
commander_1.program.option('-v, --verbose', 'define verbosity to show execution logs', increaseVerbosity, 0);
(0, auth_1.initializeAuthCommands)(commander_1.program);
commander_1.program
    .command('init')
    .argument('<path>', 'path to folder with Mamoru project', parseOrCreateDirectoryPath, '')
    .addOption(new commander_1.Option('-t, --type <type>', 'Type of project')
    .choices(['sql', 'wasm'])
    .default('wasm'))
    .addOption(new commander_1.Option('-c, --chain <chain...>', 'Chain where the Agent runs').choices((0, utils_1.getAvailableChains)()))
    .addOption(new commander_1.Option('-n, --name <name>', 'Name of the project'))
    .addOption(new commander_1.Option('-d, --description <description>', 'Description of the project').default('Mamoru Agent'))
    .addOption(new commander_1.Option('-t, --tags <tags>', 'Tags of the project, comma separated').default('mamoru,agent'))
    .addOption(new commander_1.Option('-l, --logo <logo>', 'Logo of the project, should be an url').default('https://mamoru.ai/default-agent-logo.png'))
    .addOption(new commander_1.Option('--subscribable', 'If the project is subscribable, or standalone').default(false))
    .addOption(new commander_1.Option('--skipTelemetry', 'Skip telemetry question, useful for CI/CD'))
    .description('initialize a new Agent project in a folder')
    .action(function (path, options) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, (0, ask_for_telemetry_1.askForTelemetry)(options)];
            case 1:
                _a.sent();
                return [4 /*yield*/, init_1.default.init(commander_1.program, path, options)];
            case 2:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); });
commander_1.program
    .command('build')
    .argument('[path]', 'path to folder with Mamoru project', parseOrSetCurrentDirectoryPath, '.')
    .description('compile agent project')
    .action(function (path) {
    build_1.default.build(commander_1.program, path);
});
commander_1.program
    .command('publish')
    .argument('[path]', 'path to folder with Mamoru project', parseOrSetCurrentDirectoryPath, '.')
    .option('--rpc <rpcUrl>', 'rpc url of the chain', 'http://localhost:26657')
    .addOption(new commander_1.Option('--gas <gas>', 'gas fee of the transaction  (if agent is sole, it will be used as limit for both metadata and agent creation)').default('2000000'))
    .addOption(new commander_1.Option('-k, --private-key <key>', 'Private key of the account that will be used to publish the project')
    .makeOptionMandatory()
    .env('MAMORU_PRIVATE_KEY'))
    .addOption(new commander_1.Option('-c, --chain <chain>', 'Chain to deploy').choices((0, utils_1.getAvailableChains)()))
    .addOption(new commander_1.Option('--parameters <parameters>', 'JSON stringified parameter map ie: {"key": "value"}'))
    .description('publish agent project')
    .action(function (path, options) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, (0, auth_2.isAuthRequiredGuard)()];
            case 1:
                _a.sent();
                return [4 /*yield*/, publish_1.default.publish(commander_1.program, path, options)];
            case 2:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); });
commander_1.program
    .command('launch')
    .description('launch agent from subscribable metadata')
    .addOption(new commander_1.Option('-m, --metadataId <metadataId>', 'Agent MetadataId').makeOptionMandatory())
    .option('--rpc <rpcUrl>', 'rpc url of the chain', 'http://localhost:26657')
    .addOption(new commander_1.Option('--gas <gas>', 'gas fee of the transaction').default('2000000'))
    .addOption(new commander_1.Option('-k, --private-key <key>', 'Private key of the account that will be used to publish the project')
    .makeOptionMandatory()
    .env('MAMORU_PRIVATE_KEY'))
    .addOption(new commander_1.Option('-c, --chain <chain>', 'Chain to deploy').choices((0, utils_1.getAvailableChains)()))
    .addOption(new commander_1.Option('--parameters <parameters>', 'JSON stringified parameter map ie: {"key": "value"}'))
    .action(function (options) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, (0, auth_2.isAuthRequiredGuard)()];
            case 1:
                _a.sent();
                return [4 /*yield*/, (0, launch_1.default)(commander_1.program, options)];
            case 2:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); });
commander_1.program
    .command('remove')
    .description('remove agent from validation chain')
    .argument('<id>', 'Id of the agent')
    .option('--rpc <rpcUrl>', 'rpc url of the chain', 'http://localhost:26657')
    .addOption(new commander_1.Option('-k, --private-key <key>', 'Private key of the account that will be used to publish the project')
    .makeOptionMandatory()
    .env('MAMORU_PRIVATE_KEY'))
    .action(function (id, options) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, (0, daemon_remove_1.default)(commander_1.program, id, options)];
            case 1:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); });
var playbook = commander_1.program
    .command('playbook')
    .description('Playbook related commands');
playbook
    .command('init')
    .argument('<path>', 'path to folder with Mamoru project', parseOrCreateDirectoryPath, '.')
    .description('initialize playbook in a folder')
    .addOption(new commander_1.Option('-n, --name <name>', 'Name of the playbook'))
    .action(function (path, options) {
    playbook_init_1.default.initPlaybook(commander_1.program, path, options);
});
playbook
    .command('publish')
    .argument('[path]', 'path to folder with Mamoru project', parseOrSetCurrentDirectoryPath, '.')
    .description('publish playbook')
    .option('--rpc <rpcUrl>', 'rpc url of the chain', 'http://localhost:26657')
    .addOption(new commander_1.Option('--gas <gas>', 'gas fee of the transaction').default('2000000'))
    .addOption(new commander_1.Option('-k, --private-key <key>', 'Private key')
    .makeOptionMandatory()
    .env('MAMORU_PRIVATE_KEY'))
    .addOption(new commander_1.Option('-id, --playbookId <playbookId>', 'Id of the playbook, it is required if you want to update a playbook'))
    .action(function (path, options) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, (0, auth_2.isAuthRequiredGuard)()];
            case 1:
                _a.sent();
                return [4 /*yield*/, playbook_publish_1.default.playbookPublish(commander_1.program, path, options)];
            case 2:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); });
commander_1.program.version(
// eslint-disable-next-line @typescript-eslint/no-var-requires
"Mamoru CLI ".concat(require('../package.json').version), '--version');
commander_1.program.configureOutput({
    // Visibly override write routines as example!
    writeOut: function (str) { return process.stdout.write("[OUT] ".concat(str)); },
    writeErr: function (str) { return process.stdout.write("[ERR] ".concat(str)); },
    // Highlight errors in color.
    outputError: function (str, write) {
        return write(colors_1.default.red(str));
    },
});
exports.default = commander_1.program;
//# sourceMappingURL=program.js.map