export declare function requestDeviceCode(): Promise<{
    device_code: string;
    user_code: string;
    verification_uri: string;
    expires_in: number;
    interval: number;
}>;
export declare function openDeviceActivationUrl(url: string): void;
/**
 * Request tokens, if the device code is not yet activated, poll until it is.
 * @see https://auth0.com/docs/get-started/authentication-and-authorization-flow/call-your-api-using-the-device-authorization-flow#request-tokens
 */
export declare function requestTokens(deviceCode: string): Promise<{
    access_token: string;
    expires_in: number;
    token_type: string;
}>;
/**
 * Get the user from
 */
export declare function isUserAuthenticated(): Promise<boolean>;
export declare function storeUserToken(authToken: string): void;
export declare function removeUserToken(): void;
export declare function isAuthRequiredGuard(): Promise<void>;
export declare function getAuthToken(): string;
//# sourceMappingURL=auth.service.d.ts.map