"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a, _b, _c;
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAuthToken = exports.isAuthRequiredGuard = exports.removeUserToken = exports.storeUserToken = exports.isUserAuthenticated = exports.requestTokens = exports.openDeviceActivationUrl = exports.requestDeviceCode = void 0;
var axios_1 = __importDefault(require("axios"));
var open_1 = __importDefault(require("open"));
var config_1 = require("../config");
var console_1 = require("../console");
var colors_1 = __importDefault(require("colors"));
var jsonwebtoken_1 = require("jsonwebtoken");
var jwks_rsa_1 = __importDefault(require("jwks-rsa"));
var CLIENT_ID = (_a = process.env.MAMORU_CLI_AUTH0_CLIENT_ID) !== null && _a !== void 0 ? _a : 'DKVTdw1UnneGumqOAPrEJs8RqdGTDd2e';
var DOMAIN = (_b = process.env.MAMORU_CLI_AUTH0_DOMAIN) !== null && _b !== void 0 ? _b : "mamoru.us.auth0.com";
var AUDIENCE = (_c = process.env.MAMORU_CLI_AUTH0_AUDIENCE) !== null && _c !== void 0 ? _c : 'https://mamoru.ai';
var jwksClient = (0, jwks_rsa_1.default)({
    jwksUri: "".concat(DOMAIN, "/.well-known/jwks.json"),
});
function getKey(header, callback) {
    jwksClient.getSigningKey(header.kid, function (err, key) {
        try {
            var signingKey = key.getPublicKey();
            callback(err, signingKey);
        }
        catch (err) {
            callback(err, null);
        }
    });
}
function checkAuth0Token(token) {
    return new Promise(function (resolve, reject) {
        (0, jsonwebtoken_1.verify)(token, getKey, {}, function (err, decoded) {
            if (err)
                return reject(err);
            return resolve(decoded);
        });
    });
}
function requestDeviceCode() {
    var options = {
        method: 'POST',
        url: "".concat(DOMAIN, "/oauth/device/code"),
        data: { client_id: CLIENT_ID, audience: AUDIENCE, scope: 'profile' },
    };
    return axios_1.default
        .request(options)
        .then(function (res) { return res.data; })
        .catch(function (error) {
        throw error;
    });
}
exports.requestDeviceCode = requestDeviceCode;
function openDeviceActivationUrl(url) {
    (0, open_1.default)(url);
}
exports.openDeviceActivationUrl = openDeviceActivationUrl;
/**
 * Request tokens, if the device code is not yet activated, poll until it is.
 * @see https://auth0.com/docs/get-started/authentication-and-authorization-flow/call-your-api-using-the-device-authorization-flow#request-tokens
 */
function requestTokens(deviceCode) {
    var options = {
        method: 'POST',
        url: "".concat(DOMAIN, "/oauth/token"),
        data: {
            grant_type: 'urn:ietf:params:oauth:grant-type:device_code',
            device_code: deviceCode,
            client_id: CLIENT_ID,
        },
    };
    return axios_1.default
        .request(options)
        .then(function (res) { return res.data; })
        .catch(function (error) {
        if (error.response.data.error === 'authorization_pending') {
            return null;
        }
        throw new Error(error.response.data.error_description);
    });
}
exports.requestTokens = requestTokens;
/**
 * Get the user from
 */
function isUserAuthenticated() {
    return __awaiter(this, void 0, void 0, function () {
        var config, err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    config = (0, config_1.readRcConfig)();
                    // if no authToken, return false
                    if (!config.authToken)
                        return [2 /*return*/, false];
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, checkAuth0Token(config.authToken)];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    err_1 = _a.sent();
                    return [2 /*return*/, false];
                case 4: 
                // if token check if still valid, if not, remove authToken and return false
                // if valid, return true
                return [2 /*return*/, true];
            }
        });
    });
}
exports.isUserAuthenticated = isUserAuthenticated;
function storeUserToken(authToken) {
    var config = (0, config_1.readRcConfig)();
    config.authToken = authToken;
    (0, config_1.writeRcConfig)(config);
}
exports.storeUserToken = storeUserToken;
function removeUserToken() {
    var config = (0, config_1.readRcConfig)();
    delete config.authToken;
    (0, config_1.writeRcConfig)(config);
}
exports.removeUserToken = removeUserToken;
function isAuthRequiredGuard() {
    return __awaiter(this, void 0, void 0, function () {
        var logger;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    logger = new console_1.Logger(0);
                    return [4 /*yield*/, isUserAuthenticated()];
                case 1:
                    if (!(_a.sent())) {
                        logger.error("You must be logged in to use this command, to solve it, please run\n        \n    ".concat(colors_1.default.magenta("mamoru auth login")));
                        return [2 /*return*/, process.exit(1)];
                    }
                    return [2 /*return*/];
            }
        });
    });
}
exports.isAuthRequiredGuard = isAuthRequiredGuard;
function getAuthToken() {
    var config = (0, config_1.readRcConfig)();
    return config.authToken;
}
exports.getAuthToken = getAuthToken;
//# sourceMappingURL=auth.service.js.map