"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDaemonsByIds = exports.assignOrganizationToDaemonRepeat = exports.assignOrganizationToDaemon = void 0;
var axios_1 = __importDefault(require("axios"));
var auth_1 = require("../auth");
var env_service_1 = require("../env/env.service");
function getClient() {
    var token = (0, auth_1.getAuthToken)();
    return axios_1.default.create({
        baseURL: env_service_1.GRAPHQL_BASE_URL,
        headers: __assign({}, (token ? { Authorization: "Bearer ".concat(token) } : {})),
    });
}
function assignOrganizationToDaemon(daemonId) {
    return __awaiter(this, void 0, void 0, function () {
        var query, client, r;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    query = "#graphql\n    mutation assignDaemonOrganizationId($daemonId: String!) {\n      assignDaemonOrganizationId(daemonId: $daemonId) {\n        __typename\n      }\n    }\n  ";
                    client = getClient();
                    return [4 /*yield*/, client
                            .post('', {
                            query: query,
                            variables: { daemonId: daemonId },
                        })
                            .then(function (res) {
                            if (res.data.errors) {
                                throw {
                                    response: res,
                                };
                            }
                            return res.data;
                        })
                            .catch(function (e) {
                            var _a;
                            throw ((_a = e === null || e === void 0 ? void 0 : e.response) === null || _a === void 0 ? void 0 : _a.data) || e;
                        })];
                case 1:
                    r = _a.sent();
                    return [2 /*return*/, r];
            }
        });
    });
}
exports.assignOrganizationToDaemon = assignOrganizationToDaemon;
function assignOrganizationToDaemonRepeat(daemonId, logger) {
    var _a;
    return __awaiter(this, void 0, void 0, function () {
        var INTERVAL, MAX_ATTEMPTS, attempts, res, e_1;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    INTERVAL = 3000 // 3 seconds
                    ;
                    MAX_ATTEMPTS = 100;
                    attempts = 0;
                    _b.label = 1;
                case 1:
                    if (!(attempts < MAX_ATTEMPTS)) return [3 /*break*/, 7];
                    _b.label = 2;
                case 2:
                    _b.trys.push([2, 4, , 6]);
                    return [4 /*yield*/, assignOrganizationToDaemon(daemonId)];
                case 3:
                    res = _b.sent();
                    logger.verbose("assignOrganizationToDaemon response: ".concat(JSON.stringify(res, null, 2)));
                    return [2 /*return*/, res];
                case 4:
                    e_1 = _b.sent();
                    logger.verbose("Error assigning organization to daemon: ".concat(JSON.stringify(((_a = e_1 === null || e_1 === void 0 ? void 0 : e_1.response) === null || _a === void 0 ? void 0 : _a.data) || e_1, null, 2)));
                    attempts++;
                    return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, INTERVAL); })];
                case 5:
                    _b.sent();
                    return [3 /*break*/, 6];
                case 6: return [3 /*break*/, 1];
                case 7: throw new Error("Could not assign organization to daemon after ".concat(MAX_ATTEMPTS, " attempts"));
            }
        });
    });
}
exports.assignOrganizationToDaemonRepeat = assignOrganizationToDaemonRepeat;
function getDaemonsByIds(daemonIds) {
    var _a, _b;
    return __awaiter(this, void 0, void 0, function () {
        var query, client, r;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    query = "#graphql\n    query listDaemons($daemonIds: [String!]!) {\n        listDaemons(pagination:{\n            page: 1,\n            pageSize: 100\n        }, filter:{\n            daemonIds: $daemonIds\n            \n        }){\n            items{\n            id: daemonId\n            }\n        }\n    }\n    ";
                    client = getClient();
                    return [4 /*yield*/, client
                            .post('', {
                            query: query,
                            variables: { daemonIds: daemonIds },
                        })
                            .then(function (res) {
                            if (res.data.errors) {
                                throw {
                                    response: res,
                                };
                            }
                            return res;
                        })
                            .catch(function (e) {
                            var _a;
                            throw ((_a = e === null || e === void 0 ? void 0 : e.response) === null || _a === void 0 ? void 0 : _a.data) || e;
                        })];
                case 1:
                    r = _c.sent();
                    return [2 /*return*/, (_b = (_a = r.data.data) === null || _a === void 0 ? void 0 : _a.listDaemons) === null || _b === void 0 ? void 0 : _b.items];
            }
        });
    });
}
exports.getDaemonsByIds = getDaemonsByIds;
//# sourceMappingURL=graphql-api.service.js.map