"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.joiSeverityValidator = exports.checkFolderEmptiness = exports.getNotSupportedChains = exports.getAvailableChains = exports.formatJoiError = void 0;
var chain_1 = require("@mamoru-ai/validation-chain-ts-client/dist/validationchain.validationchain/types/validationchain/validationchain/chain");
var joi_1 = __importDefault(require("joi"));
var fs_1 = __importDefault(require("fs"));
var incident_1 = require("@mamoru-ai/validation-chain-ts-client/dist/validationchain.validationchain/types/validationchain/validationchain/incident");
function formatJoiError(error) {
    var formattedExplanation = error.details
        .map(function (error, index) {
        return "".concat(index + 1, ". ").concat(error.context.message || error.message);
    })
        .join('\n');
    return "manifest contains invalid structure.\nErrors:\n".concat(formattedExplanation);
}
exports.formatJoiError = formatJoiError;
function getAvailableChains() {
    return Object.keys(chain_1.Chain_ChainType).filter(function (x) { return !(parseInt(x) >= -1 || x == 'UNRECOGNIZED' || x == 'SUI_DEVNET'); });
}
exports.getAvailableChains = getAvailableChains;
function getNotSupportedChains() {
    return Object.keys(chain_1.Chain_ChainType).filter(function (x) { return parseInt(x) == 0 || x == 'SUI_DEVNET'; });
}
exports.getNotSupportedChains = getNotSupportedChains;
function checkFolderEmptiness(program, paths) {
    paths.forEach(function (p) {
        if (fs_1.default.existsSync(p)) {
            throw new Error("Directory already contains a file named \"".concat(p, "\", stopping..."));
        }
    });
}
exports.checkFolderEmptiness = checkFolderEmptiness;
exports.joiSeverityValidator = (_a = joi_1.default
    .string())
    .valid.apply(_a, Object.values(incident_1.IncidentSeverity).filter(function (v) { return typeof v === 'string' && v !== '' && v !== 'UNRECOGNIZED'; })).required();
//# sourceMappingURL=utils.js.map